<?php
/**
 * IDEALIAGroup srl
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to info@idealiagroup.com so we can send you a copy immediately.
 *
 * @category   MSP
 * @package    MSP_CashOnDelivery
 * @copyright  Copyright (c) 2016 IDEALIAGroup srl (http://www.idealiagroup.com)
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace MSP\CashOnDelivery\Model\Total\Invoice;

use Magento\Sales\Model\Order\Invoice;
use Magento\Tax\Model\Config;

class CashondeliveryTax extends AbstractTotal
{
    
    protected $taxConfig;
    
    public function __construct(
        Config $taxConfig
    ) {
        parent::__construct();
        $this->taxConfig = $taxConfig;
    }
    
    public function collect(Invoice $invoice)
    {
        $order = $invoice->getOrder();

        $invoice->setMspCodTaxAmount($order->getMspCodTaxAmount());
        $invoice->setBaseMspCodTaxAmount($order->getBaseMspCodTaxAmount());
        
        $codBaseTaxAmount = $order->getBaseMspCodTaxAmount();
        $codTaxAmount = $order->getMspCodTaxAmount();

        if (!$this->taxConfig->displayCartPricesExclTax($order->getStoreId())) {
            if (round(($invoice->getBaseGrandTotal() - $order->getBaseGrandTotal()) - $codBaseTaxAmount) == 0) {
                $invoice->setBaseGrandTotal($invoice->getBaseGrandTotal() - $codBaseTaxAmount);
            }
            if (round(($invoice->getGrandTotal() - $order->getGrandTotal()) - $codTaxAmount) == 0) {
                $invoice->setGrandTotal($invoice->getGrandTotal() - $codTaxAmount);
            }

            $invoice->setBaseTaxAmount($invoice->getBaseTaxAmount() + $codBaseTaxAmount);
            $invoice->setTaxAmount($invoice->getTaxAmount() + $codTaxAmount);
        }

        return $this;
    }
}
